import java.awt.*;
import java.awt.event.*;
import java.util.StringTokenizer; // um die Nachricht nach Zeilen aufzutrennen

public class MessageBox extends Frame {  // zum Anzeigen einer Nachricht
	
	String message;    // die Nachricht
	String title;      // der Titel
	Button okBtn;      // zum Wegklicken der Box
	Dialog d;          // darin wird die Nachricht angezeigt
	
	//der Konstruktor sollte eigentlich nicht benutzt werden
	public MessageBox() { this("", "Meldung"); }
	
	//Titel ist "Meldung", wenn einem nichts besseres einfaellt
	public MessageBox(String msg) { this(msg, "Meldung"); }
	
	public MessageBox(String msg, String title) {
		super();
		d = new Dialog(this, title, true);
		message = msg;
		Panel p1 = new Panel(); // darin sind die Labels der Nachricht
		p1.setLayout(new GridBagLayout());
		GridBagConstraints c = new GridBagConstraints();
		c.gridx = 0; // alles in einer Spalte
		c.fill = GridBagConstraints.HORIZONTAL; // diese und die naechste Zeile
		c.weightx = 1; // bewirken, dass der Text linksbuendig ist.
		// fuer jede Zeile der msg einen Label -> nach '\n' auftrennen
		StringTokenizer st = new StringTokenizer(msg, "\n");
		while (st.hasMoreTokens()) p1.add(new Label(st.nextToken()), c);
		d.add(p1, "North");      // das Panel nach oben
		Panel p2 = new Panel();  // dieses Panel fuellt den Platz
		d.add(p2, "Center");     // in der Mitte des Dialogs
		okBtn = new Button("  Ok  ");
		okBtn.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				dispose(); // bei Klick auf OK das Fenster schliessen
			}				
		});
		Panel p3 = new Panel();   // da kommt der OK - Knopf rein
		p3.add(okBtn);
		d.add(p3, "South");       // und zwar unten in den Dialog
		d.setResizable(false);    // Groesse vom Dialog unveraenderbar
		d.pack();
		// MessageBox nicht zu klein werden lassen
		int width = d.getSize().width; int height = d.getSize().height;
		d.setSize(width > 200 ? width : 200, height > 100 ? height : 100);
		d.setLocation(300, 200); // "so ungefaehr" in die Mitte
		d.setVisible(true);      // und anzeigen
	}
	
}
