import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.util.*;

public class Nibbles extends Applet {
	
	protected boolean twoPlayers; // 1 oder 2 Spieler ?
	protected int startingLevel;  // in welchem Level gestartet wird
	
	protected ResourceBundle rBundle; // Beschriftungen usw. werden aus Datei geholt
	
	protected NibblesGame game;   // das eigentliche Spiel
	
	protected Label[] titles;     // Beschriftungen
	protected Checkbox player2;   // waehlen, ob es 2. Spieler gibt
	protected TextField name1;    // Name des 1. Spielers
	protected TextField name2;    // und des 2. Spielers
	protected TextField level;    // der Anfangslevel
	protected Button startGame;   // startet das Spiel
	
	public void MsgBox(String msg) { // zeigt Meldung an
		MessageBox mBox = new MessageBox(msg, "Nibbles"); // s. MessageBox.java
	}
	
	public void init() {
	    try {
		startingLevel = 1;   // default-maessig im 1. Level starten
		twoPlayers = false;  // default 1 Spieler
		// Resourcen laden: Datei NibblesResources*.properties
		rBundle = ResourceBundle.getBundle("NibblesResources", getLocale());
		Panel p1 = new Panel(); // da ist das Formular drin
		p1.setLayout(new GridBagLayout());
		GridBagConstraints c = new GridBagConstraints();
		c.fill = GridBagConstraints.HORIZONTAL; // hiermit und mit
		c.weightx = 1;                          // wird Linksbuendigkeit erreicht
		titles = new Label[3];                  // 3 Beschriftungen
		titles[0] = new Label(rBundle.getString("StartLevelLabel"));
		c.gridx = 1;    // 2. Spalte
		c.gridy = 0;    // 1. Zeiile
		p1.add(titles[0], c);
		titles[1] = new Label(rBundle.getString("Spieler1Label"));
		c.gridx = 1;    // 2. Spalte
		c.gridy = 1;    // 2. Zeile
		p1.add(titles[1], c);
		titles[2] = new Label(rBundle.getString("Spieler2Label"));
		titles[2].setEnabled(false); // default nur 1 Spieler, daher disabled
		c.gridx = 1;    // 2. Spalte
		c.gridy = 2;    // 3. Zeile
		p1.add(titles[2], c);
		player2 = new Checkbox();
		c.gridx = 0;    // 1. Spalte
		c.gridy = 2;    // 3. Zeile
		player2.addItemListener(new ItemListener() {
			// bei Klick 3. Zeile (de-)aktivieren und twoPlayers umschalten
			public void itemStateChanged(ItemEvent e) {
				titles[2].setEnabled(!titles[2].isEnabled());
				name2.setEnabled(!name2.isEnabled());
				twoPlayers = !twoPlayers;
			}
		});
		p1.add(player2, c);
		level = new TextField("1", 2); // erst mal 1 reinschreiben
		c.gridx = 2;   // 3. Spalte
		c.gridy = 0;   // 1. Zeile
		p1.add(level, c);
		name1 = new TextField(rBundle.getString("Spieler1Edit"));
		c.gridx = 2;   // 3. Spalte
		c.gridy = 1;   // 2. Zeile
		p1.add(name1, c);
		name2 = new TextField(rBundle.getString("Spieler2Edit"));
		name2.setEnabled(false);
		c.gridx = 2;  // 3. Spalte
		c.gridy = 2;  // 3. Zeile
		p1.add(name2, c);
		Panel p = new Panel(); // fuellt Platz
		c.gridx = 0;           // 1. Spalte
		c.gridy = 4;           // 5. Zeile
		c.gridheight = 2;      // fuellt allen Platz nach oben
		c.gridwidth = 3;       // und nach rechts aus
		p1.add(p, c);
		this.add(p1, "North"); // Formular nach oben
		Panel p2 = new Panel();// da kommt der Startknopf rein
		p2.setLayout(new FlowLayout(FlowLayout.CENTER));
		startGame = new Button(rBundle.getString("StartButton"));
		startGame.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) { //startet Spiel
				try { startingLevel = Integer.parseInt(level.getText()); }
				catch (NumberFormatException x) { 
					MsgBox(rBundle.getString("LevelFehler")); 
					startingLevel = 1;
					level.setText("1");
					return;
				}
				if ((startingLevel < 1) || (startingLevel > 9)) {
					MsgBox(rBundle.getString("LevelFehler"));
					startingLevel = 1;
					level.setText("1");
					return;
				}
				// je nach Anzahl der Spieler verschiedene Konstruktoren
				// s. NibblesGame.java
				if (twoPlayers) game = new NibblesGame(name1.getText(), name2.getText(), startingLevel, getLocale(), getCodeBase());
				else game = new NibblesGame(name1.getText(), startingLevel, getLocale(), getCodeBase());
				game.setVisible(true);
				// den 1. Level manuell starten
				game.StartNewLevel();
			}
		});
		p2.add(startGame);
		this.add(p2, "South"); // Start - Knopf am Ende
	   } catch (MissingResourceException e) { /* kommt nicht vor, in der Datei steht alles drin */ }
	}
}
