
public class Snake { // eine Schlange, besteht aus SnakeLinks
	
	// Konstanten fuer Richtung, in die sich die Schlange bewegt
	public static final int hoch   = 0;
	public static final int links  = 1;
	public static final int runter = 2;
	public static final int rechts = 3;
	
	protected int direction;  // wohin sie sich bewegt
	protected SnakeLink head; // ihr Kopf
	protected SnakeLink tail; // ihr Schwanz;
	protected int elongation; // um wieviel sie noch laenger wird
	
	public int getDirection() { return direction; }
	public void setDirection(int dir) { direction = dir; }
	public SnakeLink getTail() { return tail; }
	public int getHeadx() { return head.getx(); }
	public int getHeady() { return head.gety(); }
	public int getTailx() { return tail.getx(); } // die getTail? sind nur Abkuerzungen, man koennte
	public int getTaily() { return tail.gety(); } // ja auch getTail().get? verwenden
	
	public Snake(int x, int y) { // Anfangskoord. des Kopfes
		head = new SnakeLink(x, y, null); // kein Vorgaenger
		tail = head;    // ist ja nur 1 gross
		elongation = 2; // Anfangslaenge einer Schlange 3
	}
	
	public void Elongate(int amount) { elongation += amount; }
	
	public void Move() {
		int newX, newY;
		switch(direction) { // sollte klar sein
			case hoch:   newX = head.getx();
			             newY = head.gety() - 1;
			             break;
			case links:  newX = head.getx() - 1;
			             newY = head.gety();
			             break;
			case runter: newX = head.getx();
			             newY = head.gety() + 1;
			             break;
			case rechts: newX = head.getx() + 1;
			             newY = head.gety();
			             break;
			default: newX = head.getx(); newY = head.gety(); // kommt eh nicht vor
		}
		SnakeLink newHead = new SnakeLink(newX, newY, null);
		head.setPrev(newHead); // neuer Kopf Vorgaenger des alten Kopfes
		head = newHead;
		// falls die Schlange nicht verlaengert wird, Schwanz nachziehen
		if (elongation > 0) elongation--; else tail = tail.getPrev();
	}
}
